PLM之家PLMHome

[二次开发源码] NX二次开发源码分享:判断选择的面是否相切

2019-9-15 08:38:30 160 0

[复制链接]
admin 发表于 2019-9-15 08:38:30 |阅读模式

admin 楼主

2019-9-15 08:38:30

请使用QQ关联注册PLM之家,学习更多关于内容,更多精彩原创视频供你学习!

您需要 登录 才可以下载或查看,没有帐号?注册

x
, S& i. x& l' a3 f2 w
NX二次开发源码分享:判断选择的面是否相切( b" q5 V+ u" h# p

5 u  x5 z, p8 E9 y9 J- M; P6 t
, E0 j* E7 l1 ^/ S( I
0 a2 ^, t4 Y1 v( N' ]6 b
通常情况下,我们需要通过输入的面获取相关几何关系,如果两个面是否相切,目前并没有直接的方法去处理,如果通过自己去构造一套相切算法或者标准去处理,显然太浪费时间,而且结果是否适合,性能是否ok,都值得考量。
1 t; b& F+ a  [

" ^6 K, z% e- `8 e$ O4 v2 k
接下来我们来给大家借用目前强大的选择意图功能,来利用这个特性处理下,其实大部分几何关系都可以捕捉,掌握了这种技巧,其他的选择方式都可以以此类推的进行相关处理。
(1)先看看选择意图 Select Intention中的Selection Filter
: v6 g8 y. G; s: t" W( @8 d& v* W
选择意图主要是帮助用户在界面上进行相关对象的选取,比如选择范围,包含有整个装配范围,装配和工作部件范围,仅仅工作部件范围。选择过滤主要是针对当前选择器的选项进行相关类型的过滤,目的是帮助用户快速完成相关内容的选择。
" O4 E2 L  O! U7 m6 ~# ~/ c
譬如:
  • 当您选择曲线类型时候,NX会提供曲线相关选择
      C, t' w& N  J  B, n
- \. s; @$ O7 }+ ^5 m9 ~; A. q. L  a  d
                               
登录/注册后可看大图
  • 当您选择边对象时候,NX会提供边的相关选择方式

    : x  s7 l4 t* x/ ]. c8 o

    . |, g9 a  f; e# C* r* ?/ B                               
    登录/注册后可看大图
  • 当您选择曲面时候,NX会提供曲面的相关选择方式

    . z+ r( e$ n  x, n- ^

    $ q) {+ |# }# q( u4 C7 S                               
    登录/注册后可看大图

    , j" f5 S& K; T4 i8 y
  Z5 l+ [# m1 A1 N# q
(2)选择相切面的效果,如果我们选中图示高亮部分的面,通过Tangent Faces,系统会自动获取所有和这个面相切的面,并进行高亮
1 k- H& ?% x+ i3 r6 }1 G

6 x4 }' T$ ]( B! w, e                               
登录/注册后可看大图
7 R) d6 o* J: R  G
                               
登录/注册后可看大图
(3)代码中思路就简单了,输入的面获取很多相切面,只要要检查的面在获取的面中就够了吗? 显然还需要一个条件,就是两个面之间要有公共边,也就是说是相邻的。以下的集中测试结果,高亮的面是我们要判断之间是否相切的面。
7 ?9 c( [" K3 b' L1 R; I( Y& j

6 J5 a, L9 a( S$ v( Z* A5 H6 f/ O                               
登录/注册后可看大图

2 a/ _0 }3 k) F                               
登录/注册后可看大图
6 H5 \2 \' e: _8 O; g2 Z
                               
登录/注册后可看大图

0 `% h3 N% A1 E" B3 r$ z                               
登录/注册后可看大图

% q+ X9 `6 C  T* g! X                               
登录/注册后可看大图
(4)这种方式是非常高可用的,如何通过选择的面快速获取Slot faces,获取Boss Faces等等都值得使用。传统的做法,可能去遍历所有的面,通过面的法相方向,边的关系等进行处理,如果合理使用现有的NX提供的方式,可见更加快捷方便。
* s/ Q. M4 g# v( B0 g

# N% C5 I+ y1 ^: W6 A
最后把这段代码提供上来,仅供参考!
PLM之家NX二次开发板块,提供了很多源码分享,感兴趣可以常去看看哦!也欢迎大家发帖,提供好的案例分享。送人玫瑰,手有余香!
! V! x0 {- X  m1 N2 o( h
bool isTangentFaces(Face *face1 , Face *face2)
{
        UF_initialize();
        bool isTangent = false;
        int count = 0;
        int edgeCount = 0 ;
        std::vector<Face *> boundaryFaces1(0);
        FaceTangentRule *faceTangentRule1;
        ScCollector *scCollector1;
        std::vector<SelectionIntentRule *> rules1(1);
        uf_list_p_t sharedEdges = NULL;
        faceTangentRule1=workPart->ScRuleFactory()->CreateRuleFaceTangent(face1, boundaryFaces1);
        scCollector1 = workPart->ScCollectors()->CreateCollector();
        rules1[0] = faceTangentRule1;
        scCollector1->ReplaceRules(rules1, false);
        std::vector<TaggedObject *> theFaces = scCollector1->GetObjects();
        delete faceTangentRule1;
        if (theFaces.empty())
        {
                isTangent = false;
        }
        else
        {
                for (int i  =0 ; i < theFaces.size();i++)
                {
                        if (face2 == theFaces.at(i)) //checked face in the tangent faces list
                        {
                                UF_MODL_ask_shared_edges(face1->Tag(),face2->Tag(),&sharedEdges);
                                if (sharedEdges != NULL)  //confirm has shared edges
                                {
                                        UF_MODL_delete_list(&sharedEdges); //free the memory
                                        isTangent = true;
                                        break;
                                }
                        }
                }
& L7 g4 E1 V8 I! k9 R! b" Z5 u1 J
        }
        UF_terminate();       
        return isTangent;
}
. Z: C. i: `$ ~0 b5 r

$ h) f/ x& M6 C7 x/ |0 A. q" O5 H( C1 W
# |( ]9 a! A9 H8 F+ c# d* P
+ Y5 n# Y! P6 y' m6 r
                               
登录/注册后可看大图

- K" t/ ]% g+ z6 @1 N" I% q
' _2 S# s) E6 g" u, S+ b6 Z
                               
登录/注册后可看大图
END
PLM之家plmhome

- Z& {3 b4 T% i+ w( g( Y                               
登录/注册后可看大图
$ \7 D0 Z7 Q; i! ?' t0 \8 X; y
▲长按二维码“识别”关注

" r3 V: Y8 F! l' I7 v0 m. ^9 c" i/ j7 |
[C++] 纯文本查看 复制代码


bool CheckDTS::isTangentFaces(Face *face1 , Face *face2)
{

        bool isTangent = false;
        int count = 0;
        std::vector<Face *> boundaryFaces1(0);
        FaceTangentRule *faceTangentRule1;
        faceTangentRule1 = workPart->ScRuleFactory()->CreateRuleFaceTangent(face1, boundaryFaces1);
        ScCollector *scCollector1;
        scCollector1 = workPart->ScCollectors()->CreateCollector();
        std::vector<SelectionIntentRule *> rules1(1);
        rules1[0] = faceTangentRule1;
        scCollector1->ReplaceRules(rules1, false);
        std::vector<TaggedObject *> theFaces = scCollector1->GetObjects();
        delete faceTangentRule1;
        
        if (theFaces.empty())
        {
                isTangent = false;
        }
        else
        {
                for (int i  =0 ; i < theFaces.size();i++)
                {
                        if (face2 == theFaces.at(i))
                        {
                                isTangent = true;
                                break;
                        }
                }

        }
        
        return isTangent;

}

: m: P1 \+ e, D) q6 w9 Y1 F' E- p
上海点团信息科技有限公司,承接UG NX,CATIA,CREO,Solidworks 等CAx软件,Teamcenter,3D Experience等PLM软件,工业4.0数字化软件的实施\二次开发\培训相关业务,详情QQ 939801026 Tel 18301858168 网址 www.diantuankj.com/ doTeam.tech
回复

使用道具 举报

发表回复

您需要登录后才可以回帖 登录 | 注册

返回列表 本版积分规则

用户组 : 管理员
邮   箱 :xduniverse@qq.com
手   机 :VIP用户可查看[申请]
Q   Q : 点击这里给我发消息
性别 : 就不告诉你
主页 :http://www.plmhome.com
个人介绍 :原西门子NX高级教务员,10多年NX培训,开发咨询,Teamcenter培训实施等

主题2245

帖子3478

积分66098

  • Tecnomatix 二次开发

    Tecnomatix 二次开发入门教程 6 实现打开PLM之家

  • Tecnomatix 二次开发

    Tecnomatix 二次开发入门教程 3 第一个hello plm

  • teamcenter四层weblog

    teamcenter 12安装好后,部署四层 inserb 生成tc

  • Tecnomatix 二次开发

    Tecnomatix 二次开发入门教程 4 设置图标效果如

  • Teamcenter12.0 汽车

    Teamcenter12.0 汽车解决方案TcAE 入门教程 *

  • 关闭

    站长推荐上一条 /1 下一条

  • 发布新帖
  • 在线客服1
  • 在线客服2
  • 微信
  • 客户端
  • 返回顶部